#include <cmdbuf.h>
#include <hex.h>
#include <string.h>

bool cmdMatchStr(CommandBuf *cmd, const char *str) {
    size_t len = strlen(str);
    if (cmd->len < len) return false;
    if (!strncmp(cmd->buf, str, len)) {
        cmd->buf += len;
        cmd->len -= len;
        return true;
    }
    return false;
}

bool cmdMatchHexNumber(CommandBuf *cmd, uint32_t *value) {
    size_t read = 0;
    size_t max_len = cmd->len;
    if (max_len > 8) max_len = 8;

    *value = 0;
    for (; read < max_len; ++read) {
        char digit;
        if (!parseHexDigit(cmd->buf[read], &digit)) break;
        *value = (*value << 4) | digit;
    }
    if (!read) return false;

    cmd->buf += read;
    cmd->len -= read;
    return true;
}

bool cmdMatchHexBytes(CommandBuf *cmd, const uint32_t count, uint8_t *value) {
    size_t i;
    if (cmd->len < (count * 2)) return false;
    for (i = 0; i < count; ++i) {
        char hi, lo;
        if (!parseHexDigit(cmd->buf[i * 2], &hi)) return false;
        if (!parseHexDigit(cmd->buf[(i * 2) + 1], &lo)) return false;
        value[i] = (hi << 4) | lo;
    }
    cmd->buf += (count * 2);
    cmd->len -= (count * 2);
    return true;
}
