#ifndef RDBSERVER_CMDBUF_H_
#define RDBSERVER_CMDBUF_H_

#include <stdbool.h>
#include <stdint.h>
#include <stdlib.h>

typedef struct CommandBuf {
    char *buf;
    size_t len;
} CommandBuf;

/* Try to consume a string literal. */
bool cmdMatchStr(CommandBuf *cmd, const char *str);
/* Try to consume a base-16 number, and return the value. */
bool cmdMatchHexNumber(CommandBuf *cmd, uint32_t *value);
/* Try to consume a hex-encoded list of bytes, and return the value. */
bool cmdMatchHexBytes(CommandBuf *cmd, const uint32_t count, uint8_t *value);

#endif